<script setup lang="ts">
import { onMounted, reactive } from "vue";
import { useUserStore } from "@/stores/users";
import dayjs from "dayjs";
import CreateApiTokenModal from "@/components/user/CreateApiTokenModal.vue";
import type { ApiTokenPrivateOut } from "@/client/types.gen";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import CopyToClipboardIcon from "@/components/CopyToClipboardIcon.vue";
import { environment } from "@/environment";
import DeleteApiTokenModal from "@/components/user/DeleteApiTokenModal.vue";

const userRepository = useUserStore();

const state = reactive<{
  loading: boolean;
  deleteTokenId: string;
  createdToken?: ApiTokenPrivateOut;
  showCreatedToken: boolean;
}>({
  loading: false,
  deleteTokenId: "",
  createdToken: undefined,
  showCreatedToken: false,
});

function fetchTokens() {
  state.loading = true;
  userRepository.fetchMyApiTokens(() => {
    state.loading = false;
  });
}

function deleteApiToken(tokenId: string) {
  state.deleteTokenId = tokenId;
}

function confirmedDeleteApiToken(tokenId: string) {
  userRepository.deleteApiToken(tokenId).finally(() => {
    state.deleteTokenId = "";
  });
}

function apiTokenCreated(token: ApiTokenPrivateOut) {
  state.createdToken = token;
}

function closeSuccessAlert() {
  state.createdToken = undefined;
  state.showCreatedToken = false;
}

onMounted(() => {
  fetchTokens();
});
</script>

<template>
  <create-api-token-modal
    modal-id="create-personal-api-token-modal"
    @token-created="apiTokenCreated"
  />
  <delete-api-token-modal
    modal-id="delete-personal-api-token-modal"
    :token="userRepository.apiTokensMapping[state.deleteTokenId]"
    @confirm-delete="confirmedDeleteApiToken"
  />
  <div
    class="row border-bottom mb-4 justify-content-between align-items-center"
  >
    <h2 class="w-fit">Personal API tokens</h2>
    <span class="w-fit" tabindex="0">
      <button
        type="button"
        class="btn btn-primary"
        data-bs-toggle="modal"
        data-bs-target="#create-personal-api-token-modal"
      >
        Create token
      </button>
    </span>
  </div>
  <h6 class="text-warning mb-3">
    <font-awesome-icon icon="fa-solid fa-triangle-exclamation" />
    If you don't know what an API token is used for then you probably don't need
    it.
    <font-awesome-icon icon="fa-solid fa-triangle-exclamation" />
  </h6>
  <p>
    When using the Rest API of CloWM, you need to authenticate yourself with API
    tokens. With an API token you can make an request to the API in the name of
    your user account. To make a request to the REST API with an API token,
    write the token in the HTTP header with the key
    <code>X-CLOWM-TOKEN</code>.<br />
    You can find an online documentation of the CloWM API at
    <a :href="environment.API_BASE_URL + '/v1/docs'" target="_blank">{{
      environment.API_BASE_URL + "/v1/docs"
    }}</a
    >.
  </p>
  <div
    v-if="state.createdToken"
    class="alert alert-success alert-dismissible"
    role="alert"
    style="min-width: 50%"
  >
    <strong>Your new API token</strong>
    <button
      type="button"
      class="btn-close"
      aria-label="Close"
      @click="closeSuccessAlert"
    ></button>
    <br />
    <div class="input-group my-2 w-fit">
      <input
        :type="state.showCreatedToken ? 'text' : 'password'"
        class="form-control"
        readonly
        :value="state.createdToken.token"
      />
      <div
        class="input-group-text cursor-pointer hover-info"
        @click="state.showCreatedToken = !state.showCreatedToken"
      >
        <font-awesome-icon
          :icon="`fa-solid fa-eye${state.showCreatedToken ? '-slash' : ''}`"
        />
      </div>
      <div class="input-group-text">
        <copy-to-clipboard-icon :text="state.createdToken.token" />
      </div>
    </div>
    <div>Make sure you save it - you won't be able to access it again.</div>
  </div>
  <table class="table table-striped align-middle caption-top">
    <caption>
      Displaying
      {{
        userRepository.apiTokens.length
      }}
      API tokens
    </caption>
    <thead>
      <tr>
        <th scope="col"><b>Name</b></th>
        <th scope="col">Scopes</th>
        <th scope="col">Created</th>
        <th scope="col">Last used</th>
        <th scope="col">Expires</th>
        <th scope="col"></th>
      </tr>
    </thead>
    <tbody v-if="state.loading">
      <tr>
        <td colspan="6" class="text-center fst-italic fw-light">Loading ...</td>
      </tr>
    </tbody>
    <tbody v-else-if="userRepository.apiTokens.length === 0">
      <tr>
        <td colspan="6" class="text-center fst-italic fw-light">
          No personal API tokens
        </td>
      </tr>
    </tbody>
    <tbody v-else>
      <tr v-for="token in userRepository.apiTokens" :key="token.token_id">
        <th scope="row">{{ token.name }}</th>
        <td>{{ token.scopes.join(", ") }}</td>
        <td>
          {{ dayjs.unix(token.created_at).format("MMM DD, YYYY") }}
        </td>
        <td v-if="token.last_used">
          {{ dayjs.unix(token.last_used).format("MMM DD, YYYY HH:mm:ss") }}
        </td>
        <td v-else>Never</td>
        <td v-if="token.expires_at">
          {{
            dayjs
              .duration(token.expires_at - dayjs().unix(), "seconds")
              .humanize(true)
          }}
        </td>
        <td v-else>Never</td>
        <td class="text-end">
          <button
            type="button"
            class="btn btn-danger btn-sm"
            data-bs-toggle="modal"
            data-bs-target="#delete-personal-api-token-modal"
            @click="deleteApiToken(token.token_id)"
          >
            Delete
          </button>
        </td>
      </tr>
    </tbody>
  </table>
</template>

<style scoped></style>
